/*

TheDailyGrind v3.0
Copyright 2008 by RatRace Software except where explicitly stated otherwise.

*/

var EFFECT_SLIDE				= 1;
var EFFECT_FADE					= 2;
var EFFECT_RESIZE_FROM_TOP		= 4;
var EFFECT_RESIZE_FROM_BOTTOM	= 8;

var numberOfTimers = 0;
var appIsBusy = false;
var widgetIsShown = false;
var ANIM_DURATION = 250;
var slideInAnimation	= {duration:0, starttime: 0, to:0, now:0, from:0, firstElement:null, timer:null};
var slideInSettings		= {duration:0, starttime: 0, to:0, now:0, from:0, firstElement:null, timer:null};
var slideInGlobalSettings = {duration:0, starttime: 0, to:0, now:0, from:0, firstElement:null, timer:null};
var slideTimersBlockStart = null;
var uniqueId = 0;
var timers = new Array();
var blackBoxDragSourcePosn;
var blackBoxDragDestPosn;
var addButtonIsPressed = false;
var mouseIsPressed = false;
var globalSettingsHeightOpened = 138;
var globalSettingsHeightClosed = 38;
var headerHeight = globalSettingsHeightClosed;
var globalSettingsContainer = null;
var DGGlobalSettingsAccumulatedTime;
var DGGlobalSettingsUpdateAccumulatedTimeFromSelection;

var globalSettingsAreVisible = false;


var DGGlobalSettingsLabelSelectionMap = new Array();
DGGlobalSettingsLabelSelectionMap["None"]	= false;
DGGlobalSettingsLabelSelectionMap["Red"]	= false;
DGGlobalSettingsLabelSelectionMap["Orange"]	= false;
DGGlobalSettingsLabelSelectionMap["Yellow"]	= false;
DGGlobalSettingsLabelSelectionMap["Green"]	= false;
DGGlobalSettingsLabelSelectionMap["Blue"]	= false;
DGGlobalSettingsLabelSelectionMap["Violet"]	= false;
DGGlobalSettingsLabelSelectionMap["Gray"]	= false;
DGGlobalSettingsLabelSelectionMap["White"]	= false;


function onshow() {

	widgetIsShown = true;

	document.getElementById('ButtonAddTimer').onclick		= DGAddTimer;
	document.getElementById('ButtonAddTimer').ondblclick	= DGAddTimer;

	DGAggregateAndSaveTimerPrefs();
	DGRepositionTimers();
	
}

function onhide() {

	widgetIsShown = false;
	DGAggregateAndSaveTimerPrefs();

}

function DGSetup()
{

	if (window.widget) {
	
		widget.onshow		= onshow;
		widget.onhide		= onhide;
		widget.onremove		= DGInstanceRemove;

	}

	return 0;

}

function DGRepositionTimers() {

	appIsBusy = true;

	var yPos = headerHeight;

	for (i = 0; i < timers.length; i++) {
	
		timers[i].handle().style.top = yPos + "px";
		timers[i].setBlackBox();
		yPos += timers[i].handle().offsetHeight;
		
	}
	
	document.getElementById('DGFooter').style.top = yPos + "px";

	appIsBusy = false;

}

function DGTimer(constructor) {
	
	// Public methods
	this.handle = getHandle;
	this.containerId = getContainerId;
	this.getContainerId = getContainerId;
	this.label = getLabel;
	this.labelColor = getLabelColor;
	this.setYPosition = setYPosition;
	this.setHeight = setHeight;
	this.setBlackBox = setBlackBox;
	this.saveTimerPrefs = saveTimerPrefs;
	this.position = getPosition;
	this.setPosition = setPosition;
	this.accumulatedTime = getAccumulatedTime;
	this.resetTimer = resetTimer;
	this.deleteTimer = deleteWithoutSlide;
	this.setSelectionMarkerVisibility = setSelectionMarkerVisibility;
	
	// instance variables
	var timerUniqueId = 0;
	var timerPosition = 0;
	var accumulator = (typeof constructor != 'undefined' && constructor != null && typeof constructor.accumulator != 'undefined' && constructor.accumulator != null) ? constructor.accumulator : 0;
	var timerHandle = null;
	
	var parentElement;
	var container;
	var dragHandle;
	var dragActionInsertionMark;
	var dragActionReleaseContainerPosition;
	var dragActionInitialContainerPosition;
	var dragActionFormalReleaseContainerPosition;
	var labelContainer;
	var labelText;
	var labelAbbreviation;
	var textField;
	var hourTextField;
	var minuteTextField;
	var secondsTextField;
	var blackBox;
	var timerContainer;
	var controlsContainer;
	var deleteContainer;
	var settingsButton;
	var altButtonFuncInterval = null;

	var copyToClipBoardContainer;
	var copyToClipboardButtonBG;
	var changedDateContainer;
	var resetContainer;
	
	var settingsContainer;
	
	var resetContainerBG;
	var copyToClipBoardContainerBG;
	var deleteContainerBG;
	
	var totalTrackersHeight;
	
	var dragContainer;
	
	var settingsButtonIsPressed;
	var playPauseButtonIsPressed;
	var labelColorContainer;
	var labelColor = (typeof constructor != 'undefined' && constructor != null && typeof constructor.labelColor != 'undefined' && constructor.labelColor != null) ? constructor.labelColor : null;
	var labelColorHighlighted;
	var labelColorSelected;
	
	var playPauseToggledDate = "";

	var settingsAreVisible;

	var trackerHeight 		= 32;
	var settingsBoxHeight	= 96;

	var dragOffsetY;
		
	var textFieldIsVisible = false;
	
	var selectionMarker;
	
	// Constructor method
	addTimer();

	// getter and setter methods
	function getAccumulatedTime() {
	
		return accumulator;
	
	}
	
	function setAccumulatedTime(newAccumulatedTime) {
	
		accumulator = newAccumulatedTime;
	
	}
	
	function getLabel() {
	
		return labelContainer.innerHTML;
	
	}

	function getLabelColor() {
	
		return labelColor;
	
	}

	function getHandle() {
	
		return container;
	
	}

	function getTimerUniqueId() {
		
		return timerUniqueId;
		
	}


	function getContainerId() {
		
		return container.id;
		
	}

	function getPosition() {
		
		return timerPosition;
		
	}

	function setPosition(aUniqueId) {
		
		timerPosition = aUniqueId;
		
	}

	function setYPosition(aPosition) {
		
		container.style.top = aPosition + "px";
	
	}

	function setHeight() {
	
		container.style.height = trackerHeight + "px";
	
	}

	function setBlackBox(opacity,zVal) {
	
		blackBox.style.opacity = (typeof opacity != 'undefined' && opacity != null) ? opacity : 0.0;
		blackBox.style.zIndex = (typeof zVal != 'undefined' && zVal != null) ? zVal : -1;
		
	}
	
	function setSelectionMarkerVisibility(isVisible) {
		
		if (isVisible) {
			
			selectionMarker.className = "DGSelectionMarker on";
		
		} else {

			selectionMarker.className = "off";
			
		}
	
	}


	// constructor / create tracker method
	function addTimer() {

		if (!appIsBusy) {

			document.getElementById('ButtonAddTimer').onclick = function () {};
			document.getElementById('ButtonAddTimer').ondblclick = function () {};

			appIsBusy = true;

			timerUniqueId = uniqueId;
			timerPosition = numberOfTimers;
	
			parentElement = document.getElementById('front');
			
			container = document.createElement("div");
			container.id = (typeof constructor != 'undefined' && constructor != null) ? constructor.containerId : 'DGContainer' + timerUniqueId;
			container.className = 'DGContainer';
	
			var func = function(event) {
				if (TDGPlugin.altKeyIsPressed()) {
				
					controlsContainer.src = "gfx/DGButtonReset.png";
					settingsButton.className = "DGDelete";
					settingsButton.src = "gfx/DGButtonDelete.png";
					
				} else {
				
					controlsContainer.src = (timerHandle == null) ? "gfx/DGButtonPlay.png" : "gfx/DGButtonPause.png";
					settingsButton.className = "DGSettingsButton";
					settingsButton.src = "gfx/DGButtonSettings.png";
					
				}
				
			};
			
			container.onmouseover = function() {
				if (altButtonFuncInterval == null) {
					func();
					altButtonFuncInterval = setInterval(function() { func(); }, 500);
				}
			};
			
			container.onmouseout = function() {
				if (altButtonFuncInterval != null) {
					clearInterval(altButtonFuncInterval);
					altButtonFuncInterval = null;
				};
				controlsContainer.src = (timerHandle == null) ? "gfx/DGButtonPlay.png" : "gfx/DGButtonPause.png";
				settingsButton.className = "DGSettingsButton";
				settingsButton.src = "gfx/DGButtonSettings.png";
			};
	
			dragHandle = document.createElement("img");
			dragHandle.id = container.id + "DragHandle";
			dragHandle.src = "gfx/DGDragHandle.png";
			dragHandle.className = "DGDraghandle";
			dragHandle.addEventListener("mousedown",mouseDownDrag,false);
			container.appendChild(dragHandle);
	
			textField = document.createElement('input');
			labelContainer = document.createElement("div");
			textField.id = container.id + "TextField";
			labelContainer.id = container.id + "Label";
		
			textField.className = "DGTextField";
			textField.type = "text";
			textField.onblur = function() {
				propagateTextFieldContentsToLabel(textField.id,labelContainer.id);
				applyLabel({withColor: labelColor});
				textField.style.opacity = 0.0;
				labelContainer.style.zIndex = 2;
				textFieldIsVisible = false;
				DGAggregateAndSaveTimerPrefs();
			}
			textField.onclick = function() {
				
				if (!TDGPlugin.altKeyIsPressed()) {
					showTextField({withTextfield:textField, withContents: labelContainer.innerHTML});
				} else {
					applyLabel({withColor: "cycle"});
				}
	
			}
			container.appendChild(textField);
		
			labelContainer.className = "DGLabel ButtonText";
			labelText = document.createTextNode((typeof constructor != 'undefined' && constructor != null && typeof constructor.label != 'undefined' && constructor.label != null) ? constructor.label : 'New Timer #' + (parseInt(timerUniqueId) + 1));
			labelContainer.appendChild(labelText);
			labelContainer.onclick = function() {
	
				if (!TDGPlugin.altKeyIsPressed()) {
					showTextField({withTextfield:textField, withContents: labelContainer.innerHTML});
				} else {
					applyLabel({withColor: "cycle"});
				}
	
			};		
			container.appendChild(labelContainer);
	
			labelAbbreviation = document.createElement("div");
			labelAbbreviation.id = container.id + "LabelAbbreviation";
			labelAbbreviation.className = "off";
			var labelAbbreviationText = document.createTextNode('...');
			labelAbbreviation.appendChild(labelAbbreviationText);
			container.appendChild(labelAbbreviation);
		
			timerContainer = document.createElement("div");
			timerContainer.id = container.id + "TimerLabel";
			timerContainer.className = "DGTimerLabel ButtonText";
	
			var	timerText = document.createTextNode('000.00.00');
			timerContainer.appendChild(timerText);
			container.appendChild(timerContainer);
	
			hourTextField = document.createElement('input');
			hourTextField.id = container.id + "HourTextField";
			hourTextField.size = "3";
			hourTextField.maxLength = "3";
			hourTextField.className = "DGHourTextField";
			hourTextField.onclick = function() {
	
				var contents	= parseInt((accumulator / 3600) % 1000);

				if (contents >= 100) {
				
					contentString = contents.toString();
				
				} else if (contents < 100 && contents >= 10) {
				
					contentString = "0" + contents.toString();
						
				} else if (contents < 10) {
			
					contentString = "00" + contents.toString();
				
				}
	    		showTextField({withTextfield:hourTextField, withContents: contentString });
				
			};
			hourTextField.onfocus = function() {
			
				var contents		= parseInt((accumulator / 3600) % 1000);
				if (contents >= 100) {
				
					contentString = contents.toString();
				
				} else if (contents < 100 && contents >= 10) {
				
					contentString = "0" + contents.toString();
						
				} else if (contents < 10) {
			
					contentString = "00" + contents.toString();
				
				}
		    	showTextField({withTextfield:hourTextField, withContents: contentString });
	
			};
			hourTextField.onblur = function() {
				propagateTimerTextFieldContentsToAccumulator({withObject:hourTextField});
				foo = new DGEffectController({duration:ANIM_DURATION, starttime: 0, to:0.0, now:0, from:1, firstElement:hourTextField, timer:null, withEffect: EFFECT_FADE});
			};
			container.appendChild(hourTextField);
	
	
	
			minuteTextField = document.createElement('input');
			minuteTextField.id = container.id + "MinuteTextField";
			minuteTextField.size = "2";
			minuteTextField.maxLength = "2";
			minuteTextField.className = "DGMinuteTextField";
			minuteTextField.onclick = function() {
	
				var contents	= parseInt((accumulator / 60) % 60);
	    		contents		= ((contents < 10) ? "0" + contents : contents);
	    		showTextField({withTextfield:minuteTextField, withContents: contents });
	
			};
			minuteTextField.onfocus = function() {
			
				var contents	= parseInt((accumulator / 60) % 60);
		    	contents		= ((contents < 10) ? "0" + contents : contents);
		    	showTextField({withTextfield:minuteTextField, withContents: contents });
	
			};
			minuteTextField.onblur = function() { propagateTimerTextFieldContentsToAccumulator({withObject:minuteTextField}); foo = new DGEffectController({duration:ANIM_DURATION, starttime: 0, to:0.0, now:0, from:1, firstElement:minuteTextField, timer:null, withEffect: EFFECT_FADE}); };
			container.appendChild(minuteTextField);
	
			secondsTextField = document.createElement('input');
			secondsTextField.id = container.id + "SecondsTextField";
			secondsTextField.size = "2";
			secondsTextField.maxLength = "2";
			secondsTextField.className = "DGSecondsTextField";
			secondsTextField.onclick = function() {
	
				var contents	= parseInt(accumulator % 60);
	    		contents		= ((contents < 10) ? "0" + contents : contents);
	    		showTextField({withTextfield:secondsTextField, withContents: contents });
				
			};
			secondsTextField.onfocus = function() {
	
				var contents	= parseInt(accumulator % 60);
	    		contents		= ((contents < 10) ? "0" + contents : contents);
	    		showTextField({withTextfield:secondsTextField, withContents: contents });
				
			};
			secondsTextField.onblur = function() { propagateTimerTextFieldContentsToAccumulator({withObject:secondsTextField}); foo = new DGEffectController({duration:ANIM_DURATION, starttime: 0, to:0.0, now:0, from:1, firstElement:secondsTextField, timer:null, withEffect: EFFECT_FADE}); };
			container.appendChild(secondsTextField);
	
	
			controlsContainer = document.createElement("img");
			controlsContainer.id = container.id + "Controls";
			controlsContainer.src = "gfx/DGButtonPlay.png";
			controlsContainer.className = "DGControlsPlay";
			controlsContainer.onclick = function() { if (TDGPlugin.altKeyIsPressed()) { togglePlayPauseButtonDisplay(event); resetTimer(); } else { togglePlayPauseButtonDisplay(event); toggleTimer(); } };
			controlsContainer.onmousedown = function(event) { togglePlayPauseButtonDisplay(event); };
			controlsContainer.onmouseup = function(event) { togglePlayPauseButtonDisplay(event); };
			controlsContainer.onmouseover = function(event) { togglePlayPauseButtonDisplay(event); };
			controlsContainer.onmouseout = function(event) { togglePlayPauseButtonDisplay(event); };
	
			container.appendChild(controlsContainer);
	
			settingsButton = document.createElement("img");
			settingsButton.id = container.id + "SettingsButton";
			settingsButton.src = "gfx/DGButtonSettings.png";
			settingsButton.className = "DGSettingsButton";
			settingsButton.onmouseover = function(event) { toggleSettingsButtonDisplay(event); }
			settingsButton.onmouseout = function(event) { toggleSettingsButtonDisplay(event); }
			settingsButton.onmousedown = function(event) { toggleSettingsButtonDisplay(event); }
			settingsButton.onmouseup = function(event) { toggleSettingsButtonDisplay(event); }
			settingsButton.onclick = function(event) { if (event.altKey) { deleteTimer(); } else { toggleSettings(); } };
			settingsButton.ondblclick = function(event) { if (event.altKey) { deleteTimer(); } else { toggleSettings(); } };
			container.appendChild(settingsButton);

/*			selectionMarker = document.createElement("img");
			selectionMarker.id = container.id + "SelectionMarker";
			selectionMarker.className = "off";
			selectionMarker.src = "gfx/DGSelectionMarker.png";
			container.appendChild(selectionMarker);
*/
			blackBox = document.createElement("div");
			blackBox.id = container.id + "BlackBox";
			blackBox.className = "BlackBox";
			container.appendChild(blackBox);
	
	
	
			parentElement.appendChild(container);
	
	
			
			evaluateLabelAbbreviation({withOptionalLabelId: labelContainer});
	
			if (typeof constructor != 'undefined' && constructor != null && typeof constructor.labelColor != 'undefined' && constructor.labelColor != null)
				applyLabel({withColor: constructor.labelColor});
			
			var calculateHeight = headerHeight;
			
			for (i = 0; i < timers.length; i++)
				calculateHeight += timers[i].handle().offsetHeight;
			
			window.resizeTo(272,calculateHeight + 64);
	
			if (typeof constructor != 'undefined' && constructor != null) {
	
			    addWithoutSlide();
	
			} else {
				
			    slideInAnimation.duration = ANIM_DURATION;
			    slideInAnimation.starttime = (new Date).getTime() - 13;
			    slideInAnimation.firstElement = container;
			    slideInAnimation.from = 0;
			    slideInAnimation.to = 32;
			    slideInAnimation.timer = setInterval(function() { slideTimer(); }, 13);
	
				setTimeout(
					function() {
//						textField.focus();
						textField.select();
						showTextField({withTextfield:textField, withContents: labelContainer.innerHTML});
						appIsBusy = false;
						DGAggregateAndSaveTimerPrefs();
					}
				,ANIM_DURATION);
			
			}
			
			numberOfTimers++;
			uniqueId++;
	
			if (accumulator > 0) {
	
			    updateTimerDisplay();
			    clearTimeout(timerHandle);
			    timerHandle = null;
	
			}
	
			if (typeof constructor == 'undefined' || constructor == null) {
	
			    saveTimerPrefs();
				appIsBusy = false;
	
			}
	
		}


	}

	function addTimerSettingsInterface() {

		settingsContainer = document.createElement("div");
		settingsContainer.id = container.id + "SettingsContainer";
		settingsContainer.className = "DGSettingsContainer";
		

		deleteContainer = document.createElement("div");
		deleteContainer.id = container.id + "Delete";
		deleteContainer.className = "DGDeleteButton ButtonText";
		deleteContainer.onclick = function() { deleteTimer(); };
		deleteContainer.ondblclick = function() { deleteTimer(); };

		var deleteContainerLabel = document.createTextNode('Delete');
		deleteContainer.appendChild(deleteContainerLabel);
		
		settingsContainer.appendChild(deleteContainer);

		copyToClipBoardContainer = document.createElement("div");
		copyToClipBoardContainer.id = container.id + "CopyToClipboard";
		copyToClipBoardContainer.className = "CopyToClipboard ButtonText";
		copyToClipBoardContainer.onclick = function() { copyTimerToClipboard(); };
		copyToClipBoardContainer.ondblclick = function() { copyTimerToClipboard(); };
		var copyToClipBoardContainerLabel = document.createTextNode('Copy to clipboard');
			copyToClipBoardContainer.appendChild(copyToClipBoardContainerLabel);
		settingsContainer.appendChild(copyToClipBoardContainer);
		
		
		resetContainer = document.createElement("div");
		resetContainer.id = container.id + "ResetTimer";
		resetContainer.className = "Reset ButtonText";
		resetContainer.onclick = function() { resetTimer(); };
		resetContainer.ondblclick = function() { resetTimer(); };
			var resetContainerLabel = document.createTextNode('Reset');
			resetContainer.appendChild(resetContainerLabel);
		settingsContainer.appendChild(resetContainer);
		
		
		labelColorLabel = document.createElement("div");
		labelColorLabel.className = "DGLabelColorLabel ButtonTextFlat";
		var labelColorLabelText = document.createTextNode('Label Color:');
		labelColorLabel.appendChild(labelColorLabelText);
		settingsContainer.appendChild(labelColorLabel);

		labelColorNone = document.createElement("div");
		labelColorNone.id = container.id + "LabelColorNone";
		labelColorNone.className = "DGLabelColorNone";
		labelColorNone.onclick = function() { applyLabel({withColor: 'None'}); };
		labelColorNone.ondblclick = function() { applyLabel({withColor: 'None'}); };
		settingsContainer.appendChild(labelColorNone);

		settingsContainer.appendChild(_createLabelColorButton({withColor: 'Red'}));
		settingsContainer.appendChild(_createLabelColorButton({withColor: 'Orange'}));
		settingsContainer.appendChild(_createLabelColorButton({withColor: 'Yellow'}));
		settingsContainer.appendChild(_createLabelColorButton({withColor: 'Green'}));
		settingsContainer.appendChild(_createLabelColorButton({withColor: 'Blue'}));
		settingsContainer.appendChild(_createLabelColorButton({withColor: 'Violet'}));
		settingsContainer.appendChild(_createLabelColorButton({withColor: 'Gray'}));
		settingsContainer.appendChild(_createLabelColorButton({withColor: 'White'}));

		labelColorHighlighted = document.createElement("div");
		labelColorHighlighted.id = container.id + "LabelColorHighlighted";
		labelColorHighlighted.className = "off";
		settingsContainer.appendChild(labelColorHighlighted);

		labelColorSelected = document.createElement("div");
		labelColorSelected.id = container.id + "LabelColorSelected";
		labelColorSelected.className = "off";
		settingsContainer.appendChild(labelColorSelected);

		var creationDateContainer = document.createElement("div");
		creationDateContainer.id = container.id + "CreationDate";
		creationDateContainer.className = "DGCreationDateContainer ButtonTextFlat"
		creationDateContainer.style.fontWeight = "bold";
		var creationDateContainerLabel = document.createTextNode('Created:');
		creationDateContainer.appendChild(creationDateContainerLabel);
		settingsContainer.appendChild(creationDateContainer);

		var creationDate = document.createElement("div");
		creationDate.id = container.id + "CreationDate";
		creationDate.className = "DGCreationDate ButtonTextFlat"
		var creationDateLabel = document.createTextNode(creationDateString());
		creationDate.appendChild(creationDateLabel);
		settingsContainer.appendChild(creationDate);

		changedDateContainer = document.createElement("div");
		changedDateContainer.id = container.id + "ChangedDate";
		changedDateContainer.className = "DGChangedDateContainer ButtonTextFlat";
		changedDateContainer.style.fontWeight = "bold";
		var changedDateContainerLabel = document.createTextNode('Changed:');
		changedDateContainer.appendChild(changedDateContainerLabel);
		settingsContainer.appendChild(changedDateContainer);

		changedDate = document.createElement("div");
		changedDate.id = container.id + "ChangedDate";
		changedDate.className = "DGChangedDate ButtonTextFlat"
		var changedDateLabel = document.createTextNode(changedDateString());
		changedDate.appendChild(changedDateLabel);
		settingsContainer.appendChild(changedDate);

		labelColorSelected.className = "DGLabelMarker" + labelColor + ((labelColor != "None") ? " on" : " off");
		labelColorSelected.backGroundImage = "gfx/DGLabelColorSelected.png";

		container.appendChild(settingsContainer);

		resetContainerBG = _addButtonBackdrop({withObject: resetContainer});
		settingsContainer.appendChild(resetContainerBG);
		resetContainerBG.className = "off";
		resetContainer.onmouseover = function () {

			resetContainer.className = "Reset ButtonTextHighlighted";
			resetContainerBG.className = "on";
			
		}
		resetContainer.onmouseout = function () {

			resetContainer.className = "Reset ButtonText";
			resetContainerBG.className = "off";
			
		}

		copyToClipBoardContainerBG = _addButtonBackdrop({withObject: copyToClipBoardContainer});
		settingsContainer.appendChild(copyToClipBoardContainerBG);
		copyToClipBoardContainerBG.className = "off";
		copyToClipBoardContainer.onmouseover = function () {

			copyToClipBoardContainer.className = "CopyToClipboard ButtonTextHighlighted";
			copyToClipBoardContainerBG.className = "on";
			
		}
		copyToClipBoardContainer.onmouseout = function () {

			copyToClipBoardContainer.className = "CopyToClipboard ButtonText";
			copyToClipBoardContainerBG.className = "off";
			
		}

		deleteContainerBG = _addButtonBackdrop({withObject: deleteContainer});
		settingsContainer.appendChild(deleteContainerBG);
		deleteContainerBG.className = "off";
		deleteContainer.onmouseover = function () {

			deleteContainer.className = "DGDeleteButton ButtonTextHighlighted";
			deleteContainerBG.className = "on";
			
		}
		deleteContainer.onmouseout = function () {

			deleteContainer.className = "DGDeleteButton ButtonText";
			deleteContainerBG.className = "off";
			
		}	

	}

	function _createLabelColorButton(constructor) {
	
		// constructor.withColor
		
		var labelColorButton = document.createElement("div");
		labelColorButton.id = container.id + "labelColor" + constructor.withColor;
		labelColorButton.className = "DGlabelColor" + constructor.withColor;
		labelColorButton.onclick = function() { applyLabel({withColor: constructor.withColor}); };
		labelColorButton.ondblclick = function() { applyLabel({withColor: constructor.withColor}); };
		labelColorButton.onmouseover = function() { displayLabelColorMarker(constructor.withColor); };
		labelColorButton.onmouseout = function() { displayLabelColorMarker(); };
	
		return labelColorButton;
	
	}

	function deleteTimer(constructor) {

		// constructor.deleteWithoutAnimation

		if (!appIsBusy) {

			document.getElementById('ButtonAddTimer').onclick = function () {};
			document.getElementById('ButtonAddTimer').ondblclick = function () {};

			if (typeof deleteContainer != 'undefined')
				deleteContainer.onclick = function () {} ;

			appIsBusy = true;

			clearTimeout(timerHandle);
			timerHandle = null;

			blackBox.style.height = container.offsetHeight + "px";
			blackBox.style.top = "0px";			
			slideInAnimation.duration = ANIM_DURATION;
			slideInAnimation.starttime = (new Date).getTime() - 13;
			slideInAnimation.firstElement = container;
			slideInAnimation.from	= container.offsetHeight;
			slideInAnimation.to		= 0;
			
			slideInAnimation.timer = setInterval(function() { slideTimer(true); }, 13);

		}
		
	}
			
	function toggleTimer() {
		
		if (timerHandle == null) {

			playPauseToggledDate = (new Date).getTime().toString();
				
			timerHandle = setInterval(
				function() {
					accumulator++;
					updateTimerDisplay();
					if (typeof changedDate != 'undefined')
						changedDate.innerHTML = changedDateString();
				},1000);
//			controlsContainer.className = "DGControlsPause";
			controlsContainer.src		= "gfx/DGButtonPause.png";

		} else {

			playPauseToggledDate = "";
	
			clearInterval(timerHandle);
			timerHandle = null;
//			controlsContainer.className = "DGControlsPlay";
			controlsContainer.src		= "gfx/DGButtonPlay.png";
		
		}
	
	}
		
	function togglePlayPauseButtonDisplay(event) {

		if (timerHandle != null) {
		
			switch (event.type) {
			
				case "mousedown":
					playPauseButtonIsPressed = true;
					document.addEventListener("mouseup",resetPlayPauseButtonState,false);
					buttonValue = (TDGPlugin.altKeyIsPressed()) ? "gfx/DGButtonReset_down.png" : "gfx/DGButtonPause_down.png";
					break;
				
				case "mouseup":
					playPauseButtonIsPressed = false;
					buttonValue = (TDGPlugin.altKeyIsPressed()) ? "gfx/DGButtonReset.png" : "gfx/DGButtonPlay.png";
					break;

				case "mouseout":
					buttonValue = (playPauseButtonIsPressed) ? ((TDGPlugin.altKeyIsPressed()) ? "gfx/DGButtonReset.png" : "gfx/DGButtonPause.png") : null;
					break;				

				case "mouseover":
					buttonValue = (playPauseButtonIsPressed) ? ((TDGPlugin.altKeyIsPressed()) ? "gfx/DGButtonReset_down.png" : "gfx/DGButtonPause_down.png") : null;
					break;				
			
			}
				
		} else {
		
			switch (event.type) {
			
				case "mousedown":
					document.addEventListener("mouseup",resetPlayPauseButtonState,false);
					playPauseButtonIsPressed = true;
					buttonValue = (TDGPlugin.altKeyIsPressed()) ? "gfx/DGButtonReset_down.png" : "gfx/DGButtonPlay_down.png";
					break;
				
				case "mouseup":
					playPauseButtonIsPressed = false;
					buttonValue = (TDGPlugin.altKeyIsPressed()) ? "gfx/DGButtonReset.png" : "gfx/DGButtonPause.png";
					break;

				case "mouseout":
					buttonValue = (playPauseButtonIsPressed) ? ((TDGPlugin.altKeyIsPressed()) ? "gfx/DGButtonReset.png" : "gfx/DGButtonPlay.png") : null;
					break;

				case "mouseover":
					buttonValue = (playPauseButtonIsPressed) ? ((TDGPlugin.altKeyIsPressed()) ? "gfx/DGButtonReset_down.png" : "gfx/DGButtonPlay_down.png") : null;
					break;
			
			}
		
		} 

		if (buttonValue != null)
			controlsContainer.src = buttonValue;
	
	}
	

	function resetPlayPauseButtonState() {

		playPauseButtonIsPressed = false;
		controlsContainer.src = (TDGPlugin.altKeyIsPressed()) ? "gfx/DGButtonReset.png" : "gfx/DGButtonPlay.png";
		document.removeEventListener("mouseup",resetPlayPauseButtonState,false);

	}

	
	function toggleSettingsButtonDisplay(event) {
	
	    var buttonValue = null;
		
	    switch (event.type) {
	
	    	case "mousedown":
				document.addEventListener("mouseup",resetSettingsButtonState,false);
	    		settingsButtonIsPressed = true;
	    		buttonValue = (TDGPlugin.altKeyIsPressed()) ? "gfx/DGButtonDelete_down.png" : "gfx/DGButtonSettings_down.png";
	    		break;
	    		
	    	case "mouseup":
	    		settingsButtonIsPressed = false;
	    		buttonValue = (TDGPlugin.altKeyIsPressed()) ? "gfx/DGButtonDelete.png" : "gfx/DGButtonSettings.png";
	    		break;
	
	    	case "mouseover":
	    		buttonValue = (settingsButtonIsPressed) ? ((TDGPlugin.altKeyIsPressed()) ? "gfx/DGButtonDelete_down.png" : "gfx/DGButtonSettings_down.png") : null;
	    		break;
	    	
	    	case "mouseout":
	    		buttonValue = (settingsButtonIsPressed) ? ((TDGPlugin.altKeyIsPressed()) ? "gfx/DGButtonDelete.png" : "gfx/DGButtonSettings.png") : null;
	    		break;
	
	    }
	
	    if (buttonValue != null)
	    	settingsButton.src = buttonValue;
	
	}


	function resetSettingsButtonState() {
	
		settingsButtonIsPressed = false;
		settingsButton.src = (TDGPlugin.altKeyIsPressed()) ? "gfx/DGButtonDelete.png" : "gfx/DGButtonSettings.png";
		document.removeEventListener("mouseup",resetSettingsButtonState,false);

	}



	function updateTimerDisplay() {

		// TDGPlugin.formatTime(accumulator);
		
		if (widgetIsShown) {

			timerContainer.innerHTML = TDGPlugin.formatTime(accumulator);

		}

		saveTimerPrefs();

	}

	function copyTimerToClipboard() {

		if (!appIsBusy) {

			blackBox.style.zIndex = 1;
			blackBox.style.backgroundColor = "white";

			foo = new DGEffectController({duration:0, starttime: 0, to:0.0, now:0, from:0.5, firstElement:blackBox, timer:null, withEffect: EFFECT_FADE});

			setTimeout(function() { blackBox.style.backgroundColor = 'black'; blackBox.style.zIndex = -1;},ANIM_DURATION);

			var seconds = parseInt(accumulator % 60);
			var minutes = parseInt((accumulator / 60) % 60);
			var hours	= parseInt((accumulator / 3600) % 1000);

			var contents		= parseInt((accumulator / 3600) % 1000);

			if (contents >= 100) {
    		
    			contentString = contents.toString();
    		
    		} else if (contents < 100 && contents >= 10) {
    		
    			contentString = "0" + contents.toString();
    				
    		} else if (contents < 10) {
    	
    			contentString = "00" + contents.toString();
    		
    		}
				
			timerDisplayString = (hours) + ":" + ((minutes < 10) ? "0" + minutes : minutes) + "." + ((seconds < 10) ? "0" + seconds : seconds);
	
			if (window.widget)
				var foo = widget.system("/bin/echo '" + labelContainer.innerHTML + ": " + timerDisplayString + "' | /usr/bin/pbcopy", null);
	

		}

	}

	function resetTimer() {
	
		accumulator = 0;
		saveTimerPrefs();
		updateTimerDisplay();
		
		if (typeof changedDate != 'undefined' && changedDate != null)
			changedDate.innerHTML = changedDateString({forceUpdate: true});
	
	}

	function saveTimerPrefs() {

		if (window.widget) {

			if (typeof widget.preferenceForKey(widget.identifier + "-" + container.id + "CreationDate") == 'undefined' || widget.preferenceForKey(widget.identifier + "-" + container.id + "CreationDate") == null) {
			
				widget.setPreferenceForKey((new Date).getTime().toString(),widget.identifier + "-" + container.id + "CreationDate");
			
			}

 			widget.setPreferenceForKey(numberOfTimers.toString(),widget.identifier + "-DGNumberOfTimers");
 			
 			widget.setPreferenceForKey(labelContainer.innerHTML,widget.identifier + "-" + container.id + "Label");
 			widget.setPreferenceForKey(accumulator.toString(),widget.identifier + "-" + container.id + "Accumulator");

			widget.setPreferenceForKey(labelColor,widget.identifier + "-" + container.id + "LabelColor");
			
			changedDateString();
			
			widget.setPreferenceForKey(playPauseToggledDate,widget.identifier + "-" + container.id + "PlayPauseToggledDate");
	
		}

	}


	function deleteTimerPrefs() {
	
		if (window.widget) {

 			widget.setPreferenceForKey(numberOfTimers.toString(),widget.identifier + "-DGNumberOfTimers");

 			widget.setPreferenceForKey(null,widget.identifier + "-" + container.id + "Label");
 			widget.setPreferenceForKey(null,widget.identifier + "-" + container.id + "Accumulator");
 			widget.setPreferenceForKey(null,widget.identifier + "-" + container.id + "CreationDate");
			widget.setPreferenceForKey(null,widget.identifier + "-" + container.id + "ChangedDate");
			widget.setPreferenceForKey(null,widget.identifier + "-" + container.id + "PlayPauseToggledDate");
			widget.setPreferenceForKey(null,widget.identifier + "-" + container.id + "LabelColor");

		}	

	}


	function propagateTextFieldContentsToLabel(aTextFieldId,aLabelId) {
		
		if (textField.value.length > 0) {

			labelContainer.setAttribute("style","width: auto;");
			
			labelContainer.innerHTML = textField.value;

			evaluateLabelAbbreviation({withOptionalLabelId: labelContainer});

			saveTimerPrefs();

		}
		
	}


	function evaluateLabelAbbreviation(constructor) {
	
		//{withOptionalLabelId: aLabelId}

		var actualWidth = parseInt(document.defaultView.getComputedStyle(constructor.withOptionalLabelId, '').getPropertyValue("width"));
    	
    	if (actualWidth > 100) {
    		constructor.withOptionalLabelId.setAttribute("style","clip: rect(0,85,16,0);");
    		labelAbbreviation.className = "DGLabelAbbreviation ButtonText on";
    	} else {
    		labelAbbreviation.className = "off";
    	}
	
	}

	
	function showTextField(constructor) {
		
		// withTextfield: aTextfieldId, withContents: contents
		
		if (constructor.withTextfield.style.opacity != 1.0) {
		
			if (constructor.withTextfield == textField)
				labelContainer.style.zIndex = -2;
	
			constructor.withTextfield.value = constructor.withContents;
			constructor.withTextfield.style.opacity = 1.0;
			
			// Due to what appears to be a bug in webkit this is commented out
			// (CSS opacity and .select() results in mis-positioning when used on input fields)
			constructor.withTextfield.select();
		
		}
		
	}


	function propagateTimerTextFieldContentsToAccumulator(constructor) {
	
		// constructor.withObject
		var bufferedAccumulator = parseInt(accumulator);

		switch (constructor.withObject) {
		
			case hourTextField:
				if (bufferedAccumulator > 0) {
					bufferedAccumulator -= (parseInt(bufferedAccumulator / 3600) * 3600);
				}
				bufferedAccumulator += parseInt(DGStripChars(hourTextField.value) * 3600);
				break;

			case minuteTextField:
				if (bufferedAccumulator > 0) {
					bufferedAccumulator -= parseInt((accumulator / 60) % 60) * 60;
				}
				bufferedAccumulator += (DGStripChars(minuteTextField.value) * 60) ;
				break;

			case secondsTextField:
				if (bufferedAccumulator > 0) {
					bufferedAccumulator -= parseInt(bufferedAccumulator % 60);
				}
				bufferedAccumulator += parseInt(DGStripChars(secondsTextField.value));
				break;
		
		}

		accumulator = bufferedAccumulator;
		updateTimerDisplay();
	
	}

	function addWithoutSlide() {
	
		container.style.top = (((timerPosition + 1) * trackerHeight) + 6) + "px";
		container.style.height = trackerHeight + "px";
		blackBox.style.zIndex = -1;

    	document.getElementById("DGFooter").style.top = (((timerPosition + 2) * trackerHeight) + 6) + "px";

		document.getElementById('ButtonAddTimer').onclick		= DGAddTimer;
		document.getElementById('ButtonAddTimer').ondblclick	= DGAddTimer;

		appIsBusy = false;

	}

	function deleteWithoutSlide() {

		var slideTimersBlockStart;

		for (i = 0; i < timers.length; i++) {
    		
    		if (timers[i].containerId() == container.id) {
    			
    			slideTimersBlockStart = i;
    			break;
    			
    		}
    		
		}
	
		parentElement.removeChild(container);
	    numberOfTimers--;
	
	    var topSlidePos = headerHeight;
	    
	    for (i = 0; i < slideTimersBlockStart; i++)
	    	topSlidePos += timers[i].handle().offsetHeight;
	
	    for (i = slideTimersBlockStart + 1; i < timers.length; i++) {
	    
	    	timers[(i - 1)] = timers[i];
	    	timers[(i - 1)].setPosition(timers[(i - 1)].position() - 1);
	    	timers[(i - 1)].handle().style.top = topSlidePos + "px";
	    	topSlidePos += timers[(i)].handle().offsetHeight;
	
	    }
	
	    document.getElementById("DGFooter").style.top = topSlidePos + "px";
	    timers.pop();
	    
	    slideTimersBlockStart = null;
	    
	    deleteTimerPrefs();
	    
	    window.resizeTo(272,topSlidePos + 32);

	    DGAggregateAndSaveTimerPrefs();

	    
	}

	//
	// Below 'slideTimer()' method is based on 'animate()' method as provided by Apple Computers
	//
	function slideTimer(removeWhenDone) {

		var T;
		var ease;
		var time = (new Date).getTime();
		var yLoc;
		var frame;

		if (removeWhenDone != null && removeWhenDone && slideTimersBlockStart == null) {

			for (i = 0; i < timers.length; i++) {
				
				if (timers[i].containerId() == container.id) {
					
					slideTimersBlockStart = i;
					break;
					
				}
				
			}

		}

		T = limit_3(time - slideInAnimation.starttime, 0, slideInAnimation.duration);
 		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / slideInAnimation.duration));
				
		if (T >= slideInAnimation.duration) {

			yLoc = slideInAnimation.to;
    		clearInterval (slideInAnimation.timer);
    		slideInAnimation.timer = null;
    		slideInAnimation.now = slideInAnimation.to;
						
			if (removeWhenDone != null && removeWhenDone) {
	
				parentElement.removeChild(container);
				numberOfTimers--;

				var topSlidePos = headerHeight;
				
				for (i = 0; i < slideTimersBlockStart; i++)
					topSlidePos += timers[i].handle().offsetHeight;

				for (i = slideTimersBlockStart + 1; i < timers.length; i++) {
				
					timers[(i - 1)] = timers[i];
					timers[(i - 1)].setPosition(timers[(i - 1)].position() - 1);
					timers[(i - 1)].handle().style.top = topSlidePos + "px";
					topSlidePos += timers[(i)].handle().offsetHeight;

				}

				document.getElementById("DGFooter").style.top = topSlidePos + "px";
				timers.pop();
				
				slideTimersBlockStart = null;
				
				deleteTimerPrefs();
				
				window.resizeTo(272,topSlidePos + 32);
								
			} else {
				
				blackBox.style.zIndex = -1;
				container.style.height = trackerHeight + "px";

				var topSlidePos = headerHeight;

				for (i = 0; i <= slideTimersBlockStart; i++)
					topSlidePos += timers[i].handle().offsetHeight;

				for (i = slideTimersBlockStart + 1; i < timers.length; i++) {
				
					timers[i].handle().style.top = topSlidePos + "px";
					topSlidePos += timers[i].handle().offsetHeight;
					
				}
				
				document.getElementById("DGFooter").style.top = topSlidePos + "px";
					
			}
			
			DGRepositionTimers();

			DGAggregateAndSaveTimerPrefs();

			document.getElementById('ButtonAddTimer').onclick = DGAddTimer;
			document.getElementById('ButtonAddTimer').ondblclick = DGAddTimer;

		} else {
		
    		yLoc = computeNextFloat (slideInAnimation.from, slideInAnimation.to, ease);

			if (removeWhenDone != null && removeWhenDone) {

				container.style.height = parseInt(yLoc) + "px";
				blackBox.style.opacity = ((1.0 - (yLoc / slideInAnimation.from)) / 3);
				blackBox.style.zIndex = 1;
				
				var topSlidePos = container.offsetTop + container.offsetHeight;
						
				for (i = slideTimersBlockStart + 1; i < timers.length; i++) {
				
					timers[i].handle().style.top = topSlidePos + "px";
					topSlidePos += timers[i].handle().offsetHeight;
					
				}

				document.getElementById("DGFooter").style.top = topSlidePos + "px";
					
			} else {
				
				var containerDestPosn = headerHeight;
				
				for (i = 0; i < timerPosition; i++)
					containerDestPosn += timers[i].handle().offsetHeight;
				
				container.style.top = containerDestPosn + "px";
				container.style.height = parseInt(yLoc) + "px";
				document.getElementById("DGFooter").style.top = (containerDestPosn + container.offsetHeight) + "px";
				blackBox.style.opacity = 0.5 - ((yLoc - slideInAnimation.from) / 64); 
				blackBox.style.zIndex = 1;
	
			}

		}

	}

	
	function mouseDownDrag(event) {

		if (!appIsBusy) {

			appIsBusy = true;
			mouseIsPressed = true;

			setBlackBox();
			dragContainer = container.cloneNode(true);
			dragContainer.style.backgroundImage = "url('gfx/DGTimerDragBG.png')";
			dragContainer.style.zIndex = "1000";
			dragContainer.style.top = container.offsetTop + "px";
			parentElement.appendChild(dragContainer);

			container.style.zIndex = -1;

			dragOffsetY = event.y - container.offsetTop;
	
			dragActionInitialContainerPosition = timerPosition;

			document.addEventListener("mousemove",mouseMoveDrag,false);
			document.addEventListener("mouseup",mouseUpDrag,false);
			
			blackBox.style.visibility	= "hidden";
			container.style.backgroundImage = "url('gfx/DGTimerDragBG.png')";
			
			dragActionBG = document.createElement("div"); 
			dragActionBG.className = (container.offsetHeight > trackerHeight) ? "DGDragActionBGExpanded" : "DGDragActionBG";
			dragActionBG.style.top = container.offsetTop + "px";
			dragActionBG.style.zIndex = "-1";
			parentElement.appendChild(dragActionBG);
	

			totalTrackersHeight = getTotalTrackersHeight();

			dragActionInsertionMark = document.createElement("div");
			dragActionInsertionMark.className = "DGDragActionInsertionMark";
			dragActionInsertionMark.style.top = container.offsetTop;
	
			parentElement.appendChild(dragActionInsertionMark);

			dragActionFormalReleaseContainerPosition = parseInt((event.y - 22) / trackerHeight);
			dragActionFormalReleaseContainerPosition = (dragActionFormalReleaseContainerPosition > numberOfTimers) ? numberOfTimers : dragActionFormalReleaseContainerPosition;
			dragActionFormalReleaseContainerPosition = (dragActionFormalReleaseContainerPosition < 0) ? 0 : dragActionFormalReleaseContainerPosition;
			dragActionFormalReleaseContainerPosition = (dragActionFormalReleaseContainerPosition == timerPosition + 1) ? timerPosition : dragActionFormalReleaseContainerPosition;

			foo = new DGEffectController({duration:0, starttime: 0, to:0.5, now:0, from:1.0, firstElement:dragContainer, timer:null, withEffect: EFFECT_FADE});

		}
		
	}

	function mouseMoveDrag(event) {

		if (mouseIsPressed) {

			var dragActionCurrentContainerPosition = event.y - dragOffsetY;
			var dragActionCurrentContainerDiff = container.offsetHeight - dragOffsetY;
			
			if ((event.y - dragOffsetY < headerHeight)) {
			
				dragActionCurrentContainerPosition = headerHeight;
			
			}

			if ( (event.y + dragActionCurrentContainerDiff) > (headerHeight + totalTrackersHeight)) {

				dragActionCurrentContainerPosition = (headerHeight + totalTrackersHeight - container.offsetHeight);

			}


			if (event.y < (totalTrackersHeight + headerHeight) && event.y > headerHeight) {

				for (i = 0; i < timers.length; i++) {
				
					thisTimer = timers[i].handle();
					
					if (event.y >= thisTimer.offsetTop && event.y < thisTimer.offsetTop + thisTimer.offsetHeight) {
					
						break;
						
					}
				
				}

			} else if (event.y >= (totalTrackersHeight + headerHeight)) {
			
				i = timers.length - 1;
				
			} else {
			
				i = 0;
			
			}

			dragContainer.style.top = dragActionCurrentContainerPosition + "px";

			dragActionFormalReleaseContainerPosition = i;
			dragActionFormalReleaseContainerPosition = (dragActionFormalReleaseContainerPosition >= numberOfTimers) ? numberOfTimers : dragActionFormalReleaseContainerPosition;
			dragActionFormalReleaseContainerPosition = (dragActionFormalReleaseContainerPosition < 0) ? 0 : dragActionFormalReleaseContainerPosition;
			dragActionFormalReleaseContainerPosition = (dragActionFormalReleaseContainerPosition == timerPosition + 1) ? timerPosition + 1 : dragActionFormalReleaseContainerPosition;

			dragActionInsertionMark.style.top = timers[dragActionFormalReleaseContainerPosition].handle().offsetTop + ((i > timerPosition) ? timers[dragActionFormalReleaseContainerPosition].handle().offsetHeight : 0 ) + "px";

		}
		
	}

	function mouseUpDrag(event) {

		mouseIsPressed = false;

		document.removeEventListener("mousemove",mouseMoveDrag,false);
		document.removeEventListener("mouseup",mouseUpDrag,false);

		var temporaryBGElements = new Array();

		var ReposRangeStart;
		var ReposRangeEnd;
		var ReposDirection = 0;
		var loopStartVal;
		var loopEndVal;

		ReposRangeStart = timerPosition;

		if (dragActionFormalReleaseContainerPosition > timerPosition) {
		
			ReposRangeEnd	= dragActionFormalReleaseContainerPosition;
			ReposDirection	= -1;
			loopStartVal	= dragActionInitialContainerPosition + 1;
			loopEndVal		= ReposRangeEnd;
			
		} else if (dragActionFormalReleaseContainerPosition < timerPosition) {

			ReposRangeEnd	= dragActionFormalReleaseContainerPosition;
			ReposDirection	= 1;
			loopStartVal	= ReposRangeEnd;
			loopEndVal		= dragActionInitialContainerPosition - 1;
		
		} else {

			loopStartVal	= dragActionFormalReleaseContainerPosition;
			loopEndVal		= dragActionFormalReleaseContainerPosition;
			ReposRangeEnd	= dragActionFormalReleaseContainerPosition; 

		}

		dragActionReleaseContainerPosition = timers[dragActionFormalReleaseContainerPosition].handle().offsetTop;

		if (dragActionFormalReleaseContainerPosition > timerPosition) {
		
			if (timers[dragActionFormalReleaseContainerPosition].handle().offsetHeight > trackerHeight && container.offsetHeight == trackerHeight) {
		
				dragActionReleaseContainerPosition += settingsBoxHeight;

			} else if (timers[dragActionFormalReleaseContainerPosition].handle().offsetHeight == trackerHeight && container.offsetHeight > trackerHeight) {
			
				dragActionReleaseContainerPosition -= settingsBoxHeight
			
			}
		
		}

		blackBox.style.visibility	= "visible";
		blackBox.style.opacity		= "0.0";

		var elementCounter = 0;

		for (i = loopStartVal; i <= loopEndVal; i++) {

			if (dragActionFormalReleaseContainerPosition != dragActionInitialContainerPosition) {
		
				temporaryBGElements[elementCounter] = document.createElement("div"); 
	    		temporaryBGElements[elementCounter].className = (timers[i].handle().offsetHeight > trackerHeight) ? "DGDragActionBGExpanded" : "DGDragActionBG";
	    		temporaryBGElements[elementCounter].style.top = timers[i].handle().offsetTop + "px";
	    		temporaryBGElements[elementCounter].style.height = timers[i].handle().offsetHeight + "px";
	    		temporaryBGElements[elementCounter].style.zIndex = "-1";
	    		parentElement.appendChild(temporaryBGElements[elementCounter]);
	    		elementCounter++;
		
			}
					
			timers[i].handle().style.backgroundImage = "url('gfx/DGTimerDragBG.png')";
			foo = new DGEffectController({duration:0, starttime: 0, to:(timers[i].handle().offsetTop + (ReposDirection * container.offsetHeight)), now:0, from:timers[i].handle().offsetTop, firstElement:timers[i].handle(), timer:null, withEffect: EFFECT_SLIDE});
		
		}

		timers[loopEndVal].handle().style.backgroundImage = "url('gfx/DGTimerDragBG.png')";

		blackBoxDragSourcePosn = document.createElement("div");
		blackBoxDragSourcePosn.className = "BlackBox";
		blackBoxDragSourcePosn.style.top = timers[dragActionInitialContainerPosition].handle().offsetTop;
		blackBoxDragSourcePosn.style.height = timers[dragActionInitialContainerPosition].handle().offsetHeight + "px";
		blackBoxDragSourcePosn.style.opacity = 0.0;
		blackBoxDragSourcePosn.style.zIndex = -1;
		parentElement.appendChild(blackBoxDragSourcePosn);

		blackBoxDragDestPosn = document.createElement("div");
		blackBoxDragDestPosn.className = "BlackBox";
		blackBoxDragDestPosn.style.top = timers[dragActionFormalReleaseContainerPosition].handle().offsetTop;
		blackBoxDragDestPosn.style.height = timers[dragActionFormalReleaseContainerPosition].handle().offsetHeight + "px";
		blackBoxDragDestPosn.style.opacity = 0.0;
		blackBoxDragDestPosn.style.zIndex = -1;
		parentElement.appendChild(blackBoxDragDestPosn);

		foo = new DGEffectController({duration:0, starttime: 0, to:dragActionReleaseContainerPosition, now:0, from:dragContainer.offsetTop, firstElement:dragContainer, timer:null, withEffect: EFFECT_SLIDE});
		foo = new DGEffectController({duration:0, starttime: 0, to:1, now:0, from: 0.5, firstElement:dragContainer, timer:null, withEffect: EFFECT_FADE});
		foo = new DGEffectController({duration:0, starttime: 0, to:0.25, now:0, from: 0.0, firstElement:blackBoxDragSourcePosn, timer:null, withEffect: EFFECT_FADE});
		foo = new DGEffectController({duration:0, starttime: 0, to:0.25, now:0, from: 0.0, firstElement:blackBoxDragDestPosn, timer:null, withEffect: EFFECT_FADE});

		parentElement.removeChild(dragActionInsertionMark);

		setTimeout(function() {

			var draggedTimerBuffer = timers[dragActionInitialContainerPosition];

			parentElement.removeChild(blackBoxDragSourcePosn);
			parentElement.removeChild(blackBoxDragDestPosn);

			var elementCounter = 0;

			if (dragActionFormalReleaseContainerPosition > timerPosition) {

				for (i = loopStartVal; i <= loopEndVal; i++) {
					
					timers[i + ReposDirection] = timers[i];
					timers[i + ReposDirection].setPosition(i + ReposDirection);
					timers[i + ReposDirection].handle().style.backgroundImage = "url('gfx/DGTimerBG.png')";
				
					if (dragActionFormalReleaseContainerPosition != dragActionInitialContainerPosition)
						parentElement.removeChild(temporaryBGElements[elementCounter++]);
				
				}

			} else if (dragActionFormalReleaseContainerPosition < timerPosition) {

				for (i = loopEndVal; i >= loopStartVal; i--) {
					
					timers[i + ReposDirection] = timers[i];
					timers[i + ReposDirection].setPosition(i + ReposDirection);
					timers[i + ReposDirection].handle().style.backgroundImage = "url('gfx/DGTimerBG.png')";

					if (dragActionFormalReleaseContainerPosition != dragActionInitialContainerPosition)
						parentElement.removeChild(temporaryBGElements[elementCounter++]);

				}

			}

			container.style.backgroundImage = "url('gfx/DGTimerBG.png')";
			container.style.zIndex = 1000;

			draggedTimerBuffer.handle().style.top = dragActionReleaseContainerPosition + "px";

			parentElement.removeChild(dragContainer);
			parentElement.removeChild(dragActionBG);
			
			timers[dragActionFormalReleaseContainerPosition] = draggedTimerBuffer;
			timers[dragActionFormalReleaseContainerPosition].setPosition(dragActionFormalReleaseContainerPosition);

			DGRepositionTimers();
			DGAggregateAndSaveTimerPrefs();

		},ANIM_DURATION);
	}


	function getTotalTrackersHeight() {

		var aHeight = 0;
	
		for (i = 0; i < timers.length; i++) {

			aHeight += timers[i].handle().offsetHeight;

		}
		
		return aHeight;
			
	}


	function applyLabel(constructor) {

		// {withColor: aColor}
		
		var labelColors = new Array("Red", "Orange", "Yellow", "Green", "Blue", "Violet", "Gray", "White");

		var bufferedLabelColor = labelColor;
		labelColor = (constructor.withColor == null) ? 'None' : constructor.withColor;

		if (labelColor == "cycle") {

			if (bufferedLabelColor != "None") {

				for (i = 0; i < labelColors.length; i++) {
				
					if (labelColors[i] == bufferedLabelColor) {
						break;
					}
				
				}

				labelColor = (i < (labelColors.length - 1)) ? labelColors[i + 1] : "None";
	
			} else {

				labelColor = "Red";
			
			}
			
		}


		if (labelColorContainer != 'undefined' && labelColorContainer != null) {

			container.removeChild(labelColorContainer);
			labelColorContainer = null;

		}		

    	if (labelColor != "None") {

			labelColorContainer = document.createElement("div"); 
	    	labelColorContainer.className = "BlackBox";
    	
	    	labelColorContainer.style.backgroundColor = "transparent";
	
	    	labelColorContainer.style.zIndex = "1";
	    	labelColorContainer.style.opacity = "1";
	    	container.appendChild(labelColorContainer);
	
			leftItem = document.createElement("img");
			leftItem.src = "gfx/DGLabel" + labelColor + "Left.png";
			leftItem.className = "DGLabelLeft";
			labelColorContainer.appendChild(leftItem);
	
			midItem = document.createElement("img");
			midItem.src = "gfx/DGLabel" + labelColor + "Mid.png";
			midItem.className = "DGLabelMid";
			midItem.style.width = ((labelContainer.offsetWidth >= 90) ? 90 : ((labelContainer.offsetWidth < 10) ? 0 : (labelContainer.offsetWidth - 10)) + "px");

			labelColorContainer.appendChild(midItem);
	
			rightItem = document.createElement("img");
			rightItem.src = "gfx/DGLabel" + labelColor + "Right.png";
			rightItem.className = "DGLabelRight";
			rightItem.style.left = (labelContainer.offsetLeft + ((labelContainer.offsetWidth > 90) ? 84 : ((labelContainer.offsetWidth < 10) ? -6 : (labelContainer.offsetWidth - 16)))) + "px";
			labelColorContainer.appendChild(rightItem);
			
			labelContainer.className = "DGLabel ButtonTextFlat";
			
		} else {
		
			labelContainer.className = "DGLabel ButtonText";

		}
		
		if (typeof labelColorSelected != 'undefined') {
			labelColorSelected.className = "DGLabelMarker" + labelColor + ((labelColor != "None") ? " on" : " off");
			labelColorSelected.backGroundImage = "gfx/DGLabelColorSelected.png";
		}
		
		DGGlobalSettingsAccumulatedTimeFromSelection();
		saveTimerPrefs();

	}



	function displayLabelColorMarker(aColor) {
		
		if (aColor != null) {

			labelColorHighlighted.className = "DGLabelMarker" + aColor + " on";

		} else {

			labelColorHighlighted.className = "off";
		
		}
	}

	
	function creationDateString() {

		var creationDate;

		if (typeof widget.preferenceForKey(widget.identifier + "-" + container.id + "CreationDate") == 'undefined' || widget.preferenceForKey(widget.identifier + "-" + container.id + "CreationDate") == null) {
			widget.setPreferenceForKey((new Date).getTime().toString(),widget.identifier + "-" + container.id + "CreationDate");
		}

		creationDate = new Date(parseInt(widget.preferenceForKey(widget.identifier + "-" + container.id + "CreationDate")));

		var weekDays	= new Array("Su", "Mo", "Tu", "We", "Th", "Fr", "Sa");
		var months		= new Array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");

		var string = weekDays[creationDate.getDay()] + " " + creationDate.getDate() + " " + months[creationDate.getMonth()] + ", " + ((creationDate.getHours() < 10) ? "0" + creationDate.getHours() : creationDate.getHours()) + "." + ((creationDate.getMinutes() < 10) ? "0" + creationDate.getMinutes() : creationDate.getMinutes());

		return string;
	
	}

	function changedDateString(constructor) {

		var returnString;
	
		var changedDate;

    	if (timerHandle != null || (constructor != null && constructor.forceUpdate == true)) {
    		widget.setPreferenceForKey((new Date).getTime().toString(),widget.identifier + "-" + container.id + "ChangedDate");
    	}
    	if (widget.preferenceForKey(widget.identifier + "-" + container.id + "ChangedDate") != 'undefined' &&
    		widget.preferenceForKey(widget.identifier + "-" + container.id + "ChangedDate") != null) {
	    	changedDate = new Date(parseInt(widget.preferenceForKey(widget.identifier + "-" + container.id + "ChangedDate")));
		} else {
			return "-";
		}		

    	var weekDays	= new Array("Su", "Mo", "Tu", "We", "Th", "Fr", "Sa");
    	var months		= new Array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");

    	return weekDays[changedDate.getDay()] + " " + changedDate.getDate() + " " + months[changedDate.getMonth()] + ", " + ((changedDate.getHours() < 10) ? "0" + changedDate.getHours() : changedDate.getHours()) + "." + ((changedDate.getMinutes() < 10) ? "0" + changedDate.getMinutes() : changedDate.getMinutes());
	
	}
	
	
	function toggleSettings() {

		if (!appIsBusy) {
		
			appIsBusy = true;

		    slideInSettings.duration = ANIM_DURATION;
	        slideInSettings.starttime = (new Date).getTime() - 13;
	        slideInSettings.firstElement = container;
	        
	        blackBox.style.top = trackerHeight + "px";
	        blackBox.style.height = settingsBoxHeight + "px";
	        blackBox.style.zIndex = "3";
	        
	        var slideValue = 0;
	        
	        if (!settingsAreVisible) {

				addTimerSettingsInterface();
	
	            slideInSettings.from = 0;
	            slideInSettings.to = settingsBoxHeight;
	            slideValue = settingsBoxHeight;
	        	window.resizeBy(0,slideValue);
	
	    	} else {
	
	            slideInSettings.from = settingsBoxHeight;
	            slideInSettings.to = 0;
	            
	            slideValue = -settingsBoxHeight;
	
	    		foo = setTimeout(function() {
	    			window.resizeBy(0,slideValue);
	    			container.removeChild(settingsContainer);
	    		},ANIM_DURATION);

	    	}

			var bufferedTopPos = new Array();
			var bufferedTopPosCounter = 0;

			for (i = (timerPosition + 1); i < timers.length; i++) {
			
				bufferedTopPos[bufferedTopPosCounter++] = timers[i].handle().offsetTop;

			}

	        slideInSettings.timer = setInterval(function() {
	        	var returnValue = animate(slideInSettings);
	        	blackBox.style.opacity = 0.5 - ((returnValue / settingsBoxHeight) / 2);
	        	container.style.height = (trackerHeight + returnValue) + "px";
				bufferedTopPosCounter = 0;
				for (i = (timerPosition + 1); i < timers.length; i++) {
				
					if (slideInSettings.from < slideInSettings.to)
		    			timers[i].handle().style.top = (returnValue + bufferedTopPos[bufferedTopPosCounter++]) + "px";
					else
		    			timers[i].handle().style.top = (bufferedTopPos[bufferedTopPosCounter++] - (slideInSettings.from - returnValue)) + "px";
		    			
				}
				
				document.getElementById("DGFooter").style.top = timers[(timers.length - 1)].handle().offsetTop + timers[(timers.length - 1)].handle().offsetHeight;
				
	        }, 13);
		    	
	    	foo = setTimeout(function() {
	    		appIsBusy = false;
	    		blackBox.style.zIndex = -1;
	    		settingsAreVisible = !settingsAreVisible;
	    	},ANIM_DURATION);
	    }
	    
	}

}


function DGToggleAddButtonDisplay(event) {

    var buttonValue = null;

    var addButton = document.getElementById('ButtonAddTimer');

    switch (event.type) {

    	case "mousedown":
			document.addEventListener("mouseup",DGResetAddButtonState,false);
    		addButtonIsPressed = true;
    		buttonValue = "url('gfx/DGButtonAdd_down.png')";
    		break;
    		
    	case "mouseup":
    		addButtonIsPressed = false;
    		buttonValue = "url('gfx/DGButtonAdd.png')";
    		break;

    	case "mouseover":
    		buttonValue = (addButtonIsPressed) ? "url('gfx/DGButtonAdd_down.png')" : "url('gfx/DGButtonAdd.png')";
    		break;
    	
    	case "mouseout":
    		buttonValue = "url('gfx/DGButtonAdd.png')";
    		break;

    }

    if (buttonValue != null)
    	addButton.style.backgroundImage = buttonValue;

}


function DGResetAddButtonState() {

    addButtonIsPressed = false;
    document.removeEventListener("mouseup",DGResetAddButtonState,false);

}



function DGStripChars(aString) {

	aString = aString.replace(/[^0-9]/gi,"");
	aString = (aString.length == 0) ? "0" : aString;
	return aString;

}


function DGEffectController(constructor) {

	var initialTopPos;

	init();

	function init() {
	
    	constructor.duration = ANIM_DURATION;
    	constructor.starttime = (new Date).getTime() - 13;
    	
    	switch (constructor.withEffect) {

    		case EFFECT_SLIDE:
	   	    	constructor.timer = setInterval(function() { slide(); }, 13);		
    			break;
    			
    		case EFFECT_FADE:
	   	    	constructor.timer = setInterval(function() { fade(); }, 13);		
    			break;
    	
    		case EFFECT_RESIZE_FROM_TOP:
	   	    	constructor.timer = setInterval(function() { resizeFromTop(); }, 13);		
    			break;

    		case EFFECT_RESIZE_FROM_BOTTOM:
	    		initialTopPos = constructor.firstElement.offsetTop;
	   	    	constructor.timer = setInterval(function() { resizeFromBottom(); }, 13);		
    			break;
    		
    	
    	}
    		
	}
	
	function fade() {
	
		animate(constructor);
		constructor.firstElement.style.opacity = constructor.now;
		
	}

	function slide() {
	
		animate(constructor);
		constructor.firstElement.style.top = constructor.now;
		
	}

	function resizeFromTop() {
	
		animate(constructor);
		constructor.firstElement.style.height = constructor.now;

	
	}

	function resizeFromBottom() {
	
		animate(constructor);
		constructor.firstElement.style.top	  = initialTopPos + constructor.to - constructor.now;
		constructor.firstElement.style.height = constructor.now;

	
	}

}


function DGAggregateAndSaveTimerPrefs() {

	var aggregatedTimerIds = "";

   	widget.setPreferenceForKey(uniqueId.toString(),widget.identifier + "-DGUniqueIdCounter");
	widget.setPreferenceForKey(numberOfTimers.toString(),widget.identifier + "-DGNumberOfTimers");

	widget.setPreferenceForKey(document.getElementById('LabelInstanceIdentifier').innerHTML,widget.identifier + "-DGLabelIdentifier");

    if (typeof timers != 'undefined') {

    	for (i = 0; i < timers.length; i++) {

    		aggregatedTimerIds += timers[i].containerId();
    		aggregatedTimerIds += (i < (numberOfTimers - 1)) ? " " : "";
    		
    	}

    	widget.setPreferenceForKey(null,widget.identifier + "-DGAggregatedTimerIDs");
    	widget.setPreferenceForKey(aggregatedTimerIds,widget.identifier + "-DGAggregatedTimerIDs");

    }

}


function DGToggleGlobalSettingsPane(event) {

	var blackBoxOverlay;

	if (!appIsBusy) {

		appIsBusy = true;

		if (DGGlobalSettingsUpdateAccumulatedTimeFromSelection != null) {
		
			clearInterval(DGGlobalSettingsUpdateAccumulatedTimeFromSelection);
			DGGlobalSettingsUpdateAccumulatedTimeFromSelection = null;
		
		}

		var offset = 10;

		var initialTimerPositions = new Array();

		for (i = 0; i < timers.length; i++) {

			initialTimerPositions[i] = timers[i].handle().offsetTop;

		}

		var initialFooterPosition = document.getElementById("DGFooter").offsetTop;
		var initialHeaderHeight = document.getElementById("DGHeader").offsetHeight;

		slideInGlobalSettings.duration = ANIM_DURATION;
		slideInGlobalSettings.starttime = (new Date).getTime() - 13;
		slideInGlobalSettings.firstElement = null;
    
		var globalSettingsSizeDelta = (globalSettingsHeightOpened - globalSettingsHeightClosed);
	
		if (!globalSettingsAreVisible) {

			// Build the interface
			//_createLabelColorButtonForGlobalSettingsPane({withColor: "Red"});
			
			globalSettingsContainer = document.createElement("div");
			globalSettingsContainer.id = "DGGlobalSettingsPane";
			globalSettingsContainer.className = "DGGlobalSettingsPane";
			
			labelColorLabel = document.createElement("div");
			labelColorLabel.className = "DGLabelColorLabel ButtonTextFlat";
			labelColorLabel.style.top = "14px";
			var labelColorLabelText = document.createTextNode('Selection:');
			labelColorLabel.appendChild(labelColorLabelText);
			globalSettingsContainer.appendChild(labelColorLabel);

			DGGlobalSettingsAccumulatedTime = document.createElement("div");
			DGGlobalSettingsAccumulatedTime.className = "DGTimerLabel ButtonTextFlat";
			DGGlobalSettingsAccumulatedTime.style.top = "36px";
			globalSettingsContainer.appendChild(DGGlobalSettingsAccumulatedTime);

			DGGlobalSettingsUpdateAccumulatedTimeFromSelection = setInterval("DGGlobalSettingsAccumulatedTimeFromSelection();",1000);

			DGGlobalSettingsLoadSelection();

			var labelColors = new Array("None", "Red", "Orange", "Yellow", "Green", "Blue", "Violet", "Gray", "White");

			for (i = 0; i < labelColors.length; i++) {
			
				if (DGGlobalSettingsLabelSelectionMap[labelColors[i]]) {

					var foo = document.createElement("img");
					foo.src = "gfx/DGLabelColorSelected.png";
					foo.id = "DGGlobalSettingsLabelColorSelected" + labelColors[i];
					foo.className = "DGLabelMarker" + labelColors[i];
					foo.style.position = "absolute";
					foo.style.top = "13px";
		
					globalSettingsContainer.appendChild(foo);
			
				}

			}

			globalSettingsContainer.appendChild(_createLabelColorButtonForGlobalSettingsPane({withColor: 'None', withParentElement: globalSettingsContainer}));
			globalSettingsContainer.appendChild(_createLabelColorButtonForGlobalSettingsPane({withColor: 'Red', withParentElement: globalSettingsContainer}));
			globalSettingsContainer.appendChild(_createLabelColorButtonForGlobalSettingsPane({withColor: 'Orange', withParentElement: globalSettingsContainer}));
			globalSettingsContainer.appendChild(_createLabelColorButtonForGlobalSettingsPane({withColor: 'Yellow', withParentElement: globalSettingsContainer}));
			globalSettingsContainer.appendChild(_createLabelColorButtonForGlobalSettingsPane({withColor: 'Green', withParentElement: globalSettingsContainer}));
			globalSettingsContainer.appendChild(_createLabelColorButtonForGlobalSettingsPane({withColor: 'Blue', withParentElement: globalSettingsContainer}));
			globalSettingsContainer.appendChild(_createLabelColorButtonForGlobalSettingsPane({withColor: 'Violet', withParentElement: globalSettingsContainer}));
			globalSettingsContainer.appendChild(_createLabelColorButtonForGlobalSettingsPane({withColor: 'Gray', withParentElement: globalSettingsContainer}));
			globalSettingsContainer.appendChild(_createLabelColorButtonForGlobalSettingsPane({withColor: 'White', withParentElement: globalSettingsContainer}));



			DGGlobalSettingsDeleteContainer = document.createElement("div");
			DGGlobalSettingsDeleteContainer.id = globalSettingsContainer.id + "Delete";
			DGGlobalSettingsDeleteContainer.className = "DGDeleteButton ButtonText";
			DGGlobalSettingsDeleteContainer.style.top = "76px";
			DGGlobalSettingsDeleteContainer.onclick = function() { DGGlobalDelete(); };
			DGGlobalSettingsDeleteContainer.ondblclick = function() { DGGlobalDelete(); };

			var DGGlobalDeleteContainerLabel = document.createTextNode('Delete');
			DGGlobalSettingsDeleteContainer.appendChild(DGGlobalDeleteContainerLabel);
			
			globalSettingsContainer.appendChild(DGGlobalSettingsDeleteContainer);

			DGGlobalSettingsCopyToClipBoardContainer = document.createElement("div");
			DGGlobalSettingsCopyToClipBoardContainer.id = globalSettingsContainer.id + "CopyToClipboard";
			DGGlobalSettingsCopyToClipBoardContainer.className = "CopyToClipboard ButtonText";
			DGGlobalSettingsCopyToClipBoardContainer.style.top = "76px";
			DGGlobalSettingsCopyToClipBoardContainer.onclick = function() { DGGlobalCopyToClipboard(); };
			DGGlobalSettingsCopyToClipBoardContainer.ondblclick = function() { DGGlobalCopyToClipboard(); };
			var DGGlobalCopyToClipBoardContainerLabel = document.createTextNode('Copy to clipboard');
				DGGlobalSettingsCopyToClipBoardContainer.appendChild(DGGlobalCopyToClipBoardContainerLabel);
			globalSettingsContainer.appendChild(DGGlobalSettingsCopyToClipBoardContainer);
			
			
			DGGlobalSettingsResetContainer = document.createElement("div");
			DGGlobalSettingsResetContainer.id = globalSettingsContainer.id + "ResetTimer";
			DGGlobalSettingsResetContainer.className = "Reset ButtonText";
			DGGlobalSettingsResetContainer.style.top = "76px";
			DGGlobalSettingsResetContainer.onclick = function() { DGGlobalReset(); };
			DGGlobalSettingsResetContainer.ondblclick = function() { DGGlobalReset(); };
				var DGGlobalResetContainerLabel = document.createTextNode('Reset');
				DGGlobalSettingsResetContainer.appendChild(DGGlobalResetContainerLabel);
			globalSettingsContainer.appendChild(DGGlobalSettingsResetContainer);



			blackBoxOverlay = document.createElement("div");
			blackBoxOverlay.id = "DGGlobalSettingsBlackBoxOverlay";
			blackBoxOverlay.className = "DGGlobalSettingsBlackBoxOverlay";
			globalSettingsContainer.appendChild(blackBoxOverlay);

/*			var withSelectionLabel = document.createElement("div");
			withSelectionLabel.id = globalSettingsContainer.id + "WithSelectionLabel"
			withSelectionLabel.className = "DGGlobalSettingsWithSelectionLabel ButtonTextFlat";
				var withSelectionLabelText = document.createTextNode('With Selection:');
				withSelectionLabel.appendChild(withSelectionLabelText);
			globalSettingsContainer.appendChild(withSelectionLabel);
*/
			var totalTimeLabel = document.createElement("div");
			totalTimeLabel.id = globalSettingsContainer.id + "TotalTimeLabel"
			totalTimeLabel.className = "DGGlobalSettingsTotalTimeLabel ButtonTextFlat";
				var totalTimeLabelText = document.createTextNode('Total:');
				totalTimeLabel.appendChild(totalTimeLabelText);
			globalSettingsContainer.appendChild(totalTimeLabel);


			DGGlobalSettingsAccumulatedTimeFromSelection();

			document.getElementById("DGHeader").appendChild(globalSettingsContainer);


			DGGlobalSettingsResetContainerBG = _addButtonBackdrop({withObject: DGGlobalSettingsResetContainer});
			globalSettingsContainer.appendChild(DGGlobalSettingsResetContainerBG);
			DGGlobalSettingsResetContainerBG.className = "off";
			DGGlobalSettingsResetContainer.onmouseover = function () {

				DGGlobalSettingsResetContainer.className = "Reset ButtonTextHighlighted";
				DGGlobalSettingsResetContainerBG.className = "on";
				
			}
			DGGlobalSettingsResetContainer.onmouseout = function () {

				DGGlobalSettingsResetContainer.className = "Reset ButtonText";
				DGGlobalSettingsResetContainerBG.className = "off";
				
			}


			DGGlobalSettingsCopyToClipBoardContainerBG = _addButtonBackdrop({withObject: DGGlobalSettingsCopyToClipBoardContainer});
			globalSettingsContainer.appendChild(DGGlobalSettingsCopyToClipBoardContainerBG);
			DGGlobalSettingsCopyToClipBoardContainerBG.className = "off";
			DGGlobalSettingsCopyToClipBoardContainer.onmouseover = function () {

				DGGlobalSettingsCopyToClipBoardContainer.className = "CopyToClipboard ButtonTextHighlighted";
				DGGlobalSettingsCopyToClipBoardContainerBG.className = "on";
				
			}
			DGGlobalSettingsCopyToClipBoardContainer.onmouseout = function () {

				DGGlobalSettingsCopyToClipBoardContainer.className = "CopyToClipboard ButtonText";
				DGGlobalSettingsCopyToClipBoardContainerBG.className = "off";
				
			}


			DGGlobalSettingsDeleteContainerBG = _addButtonBackdrop({withObject: DGGlobalSettingsDeleteContainer});
			globalSettingsContainer.appendChild(DGGlobalSettingsDeleteContainerBG);
			DGGlobalSettingsDeleteContainerBG.className = "off";
			DGGlobalSettingsDeleteContainer.onmouseover = function () {

				DGGlobalSettingsDeleteContainer.className = "DGDeleteButton ButtonTextHighlighted";
				DGGlobalSettingsDeleteContainerBG.className = "on";
				
			}
			DGGlobalSettingsDeleteContainer.onmouseout = function () {

				DGGlobalSettingsDeleteContainer.className = "DGDeleteButton ButtonText";
				DGGlobalSettingsDeleteContainerBG.className = "off";
				
			}

			slideInGlobalSettings.from = 0;
			slideInGlobalSettings.to = globalSettingsSizeDelta;
			window.resizeBy(0,globalSettingsSizeDelta);

		} else {

			slideInGlobalSettings.from = 0;
			slideInGlobalSettings.to = -globalSettingsSizeDelta;
		
			DGGlobalSettingsSaveSelection();
		
			setTimeout(
				function() {
					window.resizeBy(0,-globalSettingsSizeDelta);
				}
			, ANIM_DURATION);
	
		}

		globalSettingsAreVisible = !globalSettingsAreVisible;

		slideInGlobalSettings.timer = setInterval(

			function () {
		
				var returnValue = animate(slideInGlobalSettings);

				for (i = 0; i < timers.length; i++) {
			
					timers[i].handle().style.top = (initialTimerPositions[i] + returnValue) + "px";

				}

				headerHeight = (initialHeaderHeight + returnValue);

				if (globalSettingsContainer)
					globalSettingsContainer.style.height = (headerHeight - globalSettingsHeightClosed) + "px"

				var fadeValue = (returnValue / slideInGlobalSettings.to) / 2;
				
				if (globalSettingsAreVisible) {
				
					fadeValue = 0.5 - fadeValue;
				
				}
				
				document.getElementById("DGGlobalSettingsBlackBoxOverlay").style.opacity = fadeValue;

				document.getElementById("DGHeader").style.height = headerHeight + "px"
				document.getElementById("DGFooter").style.top = (initialFooterPosition + returnValue) + "px";

				if (returnValue == slideInGlobalSettings.to) {

					if (!globalSettingsAreVisible && globalSettingsContainer != null) {
						document.getElementById("DGHeader").removeChild(globalSettingsContainer);
						globalSettingsContainer = null;
					}
					appIsBusy = false;
					
				}

			}
		
		,13);

	}

}

function _createLabelColorButtonForGlobalSettingsPane(constructor) {
	
	// constructor.withColor, withParentElement
		
	var labelColorButton = document.createElement("div");
	labelColorButton.id = "DGGlobalSettingsPaneLabelColor" + constructor.withColor;
	labelColorButton.className = "DGlabelColor" + constructor.withColor;
	labelColorButton.style.top = "16px";
	
	var clickDblClickFunction = function() { 
	
		DGGlobalSettingsLabelSelectionMap[constructor.withColor] = !DGGlobalSettingsLabelSelectionMap[constructor.withColor]
		DGGlobalSettingsAccumulatedTimeFromSelection();
		DGGlobalSettingsSaveSelection();
		
	};
	labelColorButton.onclick = clickDblClickFunction;
	labelColorButton.onDblClick = clickDblClickFunction;
	labelColorButton.onmouseover = function() {
	
		if (!DGGlobalSettingsLabelSelectionMap[constructor.withColor]) {

			var foo = document.createElement("img");
			foo.src = "gfx/DGLabelColorSelected.png";
			foo.id = "DGGlobalSettingsLabelColorSelected" + constructor.withColor;
			foo.className = "DGLabelMarker" + constructor.withColor;
			foo.style.position = "absolute";
			foo.style.top = "13px";
		
			constructor.withParentElement.appendChild(foo);
		
		}
		
	};
	labelColorButton.onmouseout = function() {
	
		if (!DGGlobalSettingsLabelSelectionMap[constructor.withColor])
			constructor.withParentElement.removeChild(document.getElementById("DGGlobalSettingsLabelColorSelected" + constructor.withColor));
	
	};
	
	return labelColorButton;
	
}


function DGGlobalSettingsSaveSelection() {

	var labelColors = new Array("None", "Red", "Orange", "Yellow", "Green", "Blue", "Violet", "Gray", "White");

	var labelColorsLength = labelColors.length;
	
	var encodedSelection = 0;
	
	var j = 0;
	
	for (i = 0; i < labelColorsLength; i++) {
	
		if (DGGlobalSettingsLabelSelectionMap[labelColors[i]]) {
		
			encodedSelection += 1<<i;
		
		}
		
	}

	widget.setPreferenceForKey(encodedSelection.toString(),widget.identifier + "-DGGlobalSettingsSelection");

}

function DGGlobalSettingsLoadSelection() {

	var theSavedSelection = parseInt(widget.preferenceForKey(widget.identifier + "-DGGlobalSettingsSelection"));

	var labelColors = new Array("None", "Red", "Orange", "Yellow", "Green", "Blue", "Violet", "Gray", "White");
	var labelColorsLength = labelColors.length;

	for (i = 0; i < labelColorsLength; i++) {
		
		DGGlobalSettingsLabelSelectionMap[labelColors[i]] = (theSavedSelection & 1<<i ) ? true : false ;

	}

}


function DGGlobalSettingsAccumulatedTimeFromSelection() {

	if (widgetIsShown) {
		
		var theSelection		= DGGetSelection();
		var theSelectionLength	= theSelection.length;
	
		var accumulatedTimerValues = 0;
	
		for (i = 0; i < theSelectionLength; i++) {
		
			if (typeof theSelection != 'undefined' && theSelection != null && typeof theSelection[i] != 'undefined' && theSelection[i] != null)
				accumulatedTimerValues += theSelection[i].accumulatedTime();
		
		}
	
		if (typeof DGGlobalSettingsAccumulatedTime != 'undefined' && DGGlobalSettingsAccumulatedTime != null) {
	
			DGGlobalSettingsAccumulatedTime.innerHTML = formatTime(accumulatedTimerValues);
		
		}

	}
}

function DGGetSelection() {

	var labelColors = new Array("None", "Red", "Orange", "Yellow", "Green", "Blue", "Violet", "Gray", "White");

	var returnArray = new Array();
	var returnArrayCount = 0;
	var accumulatedTimerValues = 0;

	var totalLength = timers.length * labelColors.length;
	var j = 0;
	var k = 0;
	var matchMade = false;
	
	for (i = 0; i < totalLength; i++) {

		if (DGGlobalSettingsLabelSelectionMap[labelColors[j]] && timers[k].labelColor() == labelColors[j]) {
			
			matchMade = true;
			returnArray[returnArrayCount++] = timers[k];
			
		} else {

			if (!matchMade) {

				matchMade = true;

			}
			
		}

		if (j < labelColors.length - 1) {
		
			j++;
		
		} else {
		
			matchMade = false;
			j = 0;
			k++;
			
		}

	}

	return returnArray;

}


function formatTime(aTimerValue) {

	var timerDisplayString = "";		
					
	var seconds = parseInt(aTimerValue % 60);
	var minutes = parseInt((aTimerValue / 60) % 60);
	var hours	= parseInt((aTimerValue / 3600) % 1000);
	
	if (hours >= 100) {
	
		hoursString = hours.toString();
	
	} else if (hours < 100 && hours >= 10) {
	
		hoursString = "0" + hours.toString();
			
	} else if (hours < 10) {

		hoursString = "00" + hours.toString();
	
	}
	
	return (hoursString) + "." + ((minutes < 10) ? "0" + minutes : minutes) + "." + ((seconds < 10) ? "0" + seconds : seconds);

}


function _addButtonBackdrop(constructor) {

	// constructor
	// .withObject
	// .appendTo
	// .state

	buttonBG = document.createElement("div");
	buttonBG.id = constructor.withObject.id + "ButtonBG";
	buttonBG.style.position = "absolute";
	buttonBG.style.top	= constructor.withObject.offsetTop + "px";
	buttonBG.style.left	= (constructor.withObject.offsetLeft - 8) + "px";
	buttonBG.style.opacity = "0.5";

		buttonBGLeftImg = document.createElement("img");
		buttonBGLeftImg.src = "gfx/DGLabelDarkGrayleft.png";
		buttonBGLeftImg.style.position = "absolute";
		buttonBGLeftImg.style.left = "0px";
		buttonBG.appendChild(buttonBGLeftImg);

		buttonBGMidImg = document.createElement("img");
		buttonBGMidImg.style.position = "absolute";
		buttonBGMidImg.style.left = "8px";
		buttonBGMidImg.style.height = "14px";
		buttonBGMidImg.src = "gfx/DGLabelDarkGrayMid.png";
		buttonBG.appendChild(buttonBGMidImg);

		buttonBGMidImg.style.width = constructor.withObject.offsetWidth + "px";

		buttonBGRightImg = document.createElement("img");
		buttonBGRightImg.src = "gfx/DGLabelDarkGrayRight.png";
		buttonBGRightImg.style.position = "absolute";
		buttonBGRightImg.style.left = (constructor.withObject.offsetWidth + 8) + "px";
		buttonBG.appendChild(buttonBGRightImg);

	return buttonBG;

}



function DGShowLabelIdentifierTextField() {

	var TextfieldInstanceIdentifier = document.getElementById("TextfieldInstanceIdentifier");

	TextfieldInstanceIdentifier.value = document.getElementById('LabelInstanceIdentifier').innerHTML;

	TextfieldInstanceIdentifier.style.width = "160px";

	TextfieldInstanceIdentifier.style.opacity = 1.0;
	TextfieldInstanceIdentifier.select();
	
}


function DGHideLabelIdentifierTextField() {

	var TextfieldInstanceIdentifier = document.getElementById("TextfieldInstanceIdentifier");

	document.getElementById('LabelInstanceIdentifier').innerHTML = TextfieldInstanceIdentifier.value;
	
	var actualWidth = parseInt(document.defaultView.getComputedStyle(document.getElementById("LabelInstanceIdentifier"), '').getPropertyValue("width"));

	TextfieldInstanceIdentifier.style.width = (actualWidth + 8) + "px";
	TextfieldInstanceIdentifier.style.opacity = 0.0;

}


function DGGlobalCopyToClipboard() {

	var theSelection		= DGGetSelection();
	var theSelectionLength	= theSelection.length;

	var returnString = document.getElementById('LabelInstanceIdentifier').innerHTML + "\n";

	var seconds;
	var minutes;
	var hours;
	var timerDisplayString;
	var total = 0;
	
	for (i = 0; i < theSelectionLength; i++) {
	
		seconds =	parseInt(theSelection[i].accumulatedTime() % 60);
		minutes =	parseInt((theSelection[i].accumulatedTime() / 60) % 60);
		hours	=	parseInt((theSelection[i].accumulatedTime() / 3600));
		total	+=	theSelection[i].accumulatedTime();

	    if (hours >= 100) {
	    
	    	hourstring = hours.toString();
	    
	    } else if (hours < 100 && hours >= 10) {
	    
	    	hourstring = "0" + hours.toString();
	    		
	    } else if (hours < 10) {
	
	    	hourstring = "00" + hours.toString();
	    
	    }

		timerDisplayString = (hourstring) + ":" + ((minutes < 10) ? "0" + minutes : minutes) + "." + ((seconds < 10) ? "0" + seconds : seconds);
	
		returnString += theSelection[i].label() + ":\t" + timerDisplayString + "\n";
	
	}
	
	seconds				=	parseInt(total % 60);
	minutes				=	parseInt((total / 60) % 60);
	hours				=	parseInt((total / 3600));

    if (hours >= 100) {
    
    	hourstring = hours.toString();
    
    } else if (hours < 100 && hours >= 10) {
    
    	hourstring = "0" + hours.toString();
    		
    } else if (hours < 10) {

    	hourstring = "00" + hours.toString();
    
    }
	var formattedTotal	= (hourstring) + ":" + ((minutes < 10) ? "0" + minutes : minutes) + "." + ((seconds < 10) ? "0" + seconds : seconds);

	returnString += "Total:\t" + formattedTotal;
	
	blackBoxOverlay = document.getElementById('DGGlobalSettingsBlackBoxOverlay');
	
	blackBoxOverlay.style.zIndex = 1;
	blackBoxOverlay.style.backgroundColor = "white";

	foo = new DGEffectController({duration:0, starttime: 0, to:0.0, now:0, from:0.5, firstElement:blackBoxOverlay, timer:null, withEffect: EFFECT_FADE});
	setTimeout(function() { blackBoxOverlay.style.backgroundColor = 'black'; blackBoxOverlay.style.zIndex = -1;},ANIM_DURATION);

	
	if (window.widget)
		var foo = widget.system("/bin/echo '" + returnString + "' | /usr/bin/pbcopy", null);

}

function DGGlobalReset() {

	var theSelection		= DGGetSelection();
	var theSelectionLength	= theSelection.length;
	
	for (i = 0; i < theSelectionLength; i++) {

		theSelection[i].resetTimer();

	}
	
}

function DGGlobalDelete() {

	var theSelection		= DGGetSelection();
	var theSelectionLength	= theSelection.length;

	while (theSelectionLength != 0) {
	
		theSelection[0].deleteTimer();
		theSelection		= DGGetSelection();
		theSelectionLength	= theSelection.length;

	}
	
}

function DGSoftwareUpdate() {

	alert("TDGPlugin.updateIsAvailable(): " + TDGPlugin.updateIsAvailable());

	if (TDGPlugin.updateIsAvailable()) {
		document.getElementById("DGFooter").style.textDecoration = "underline";
		document.getElementById("DGFooter").innerHTML = "v" + TDGPlugin.distantVersion() + " update is available";
	}

}

function DGVersion() {

	document.getElementById("DGFooter").innerHTML = "TheDailyGrind v" + TDGPlugin.version();

}

function DGInstanceRemove() {

	var theSelectionLength = timers.length;

	while (theSelectionLength != 0) {
	
		timers[0].deleteTimer();
		theSelectionLength	= timers.length;

	}

	widget.setPreferenceForKey(null,widget.identifier + "-DGUniqueIdCounter");
	widget.setPreferenceForKey(null,widget.identifier + "-DGNumberOfTimers");
	widget.setPreferenceForKey(null,widget.identifier + "-DGLabelIdentifier");
	widget.setPreferenceForKey(null,widget.identifier + "-DGAggregatedTimerIDs");
	widget.setPreferenceForKey(null,widget.identifier + "-DGGlobalSettingsSelection")
}

//
// Below code provided by Apple Computers.
//
// var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function animate(animationObject)
{

    var T;
    var ease;
    var time = (new Date).getTime();
           
    T = limit_3(time-animationObject.starttime, 0, animationObject.duration);
        
    if (T >= animationObject.duration)
    {
        clearInterval (animationObject.timer);
        animationObject.timer = null;
        animationObject.now = animationObject.to;

	    addButtonIsFading = false;

    }
    else
    {
    
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animationObject.duration));
        animationObject.now = computeNextFloat (animationObject.from, animationObject.to, ease);

    }

	return animationObject.now;

}
function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}